/* eslint-disable */
<template>
  <v-row justify="center">
    <v-dialog
      v-model="usersCreate"
      @keydown.esc="handleClose"
      @click:outside="handleClose"
      width="800px"
    >
      <v-card>
        <v-toolbar style="position:relative" color="white" elevation="0">
          <v-spacer />
          <v-toolbar-title class="mt-5">
            <span class="primary--text">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-account-plus</v-icon
              ><b>Adicionar usuário</b>
              <br />
            </span>
          </v-toolbar-title>
          <v-spacer />
          <v-tooltip color="red" bottom>
            <template v-slot:activator="{ on }">
              <v-icon
                v-on="on"
                style="position:absolute; right: 15px"
                color="red"
                @click="handleClose"
                >mdi-close</v-icon
              >
            </template>
            <span><b>Fechar</b> janela</span>
          </v-tooltip>
        </v-toolbar>

        <v-card-text class="scrollForm" ref="scrollY">
          <v-row no-gutters justify="center">
            <v-btn
              v-if="candAddNewUser"
              small
              class="mr-2"
              :color="actualTab == 0 ? 'grey lighten-2' : 'transparent'"
              elevation="0"
              @click="selectTab0"
              >Adicionar novo usuário no Sistema</v-btn
            >
            <v-btn
              v-if="candAddNewUser"
              small
              :color="actualTab == 1 ? 'grey lighten-2' : 'transparent'"
              elevation="0"
              @click="selectTab1"
              >Adicionar usuário nessa entidade</v-btn
            >
          </v-row>
          <v-form ref="form" v-model="valid">
            <!-- Adicionar novo usuario no banco de dados -->
            <div v-if="actualTab == 0">
              <v-container>
                <v-row>
                  <v-col cols="12" sm="12" md="6">
                    <v-text-field
                      autofocus
                      v-model="user.name"
                      label="Nome*"
                      required
                      prepend-icon="mdi-pencil-outline"
                      @keypress="validation($event, 'onlyLetters')"
                      @paste="$event.preventDefault()"
                    />
                  </v-col>
                  <v-col cols="12" sm="12" md="6">
                    <v-text-field
                      v-model="user.surname"
                      label="Sobrenome*"
                      required
                      prepend-icon="mdi-pencil-box-outline"
                      @keypress="validation($event, 'onlyLetters')"
                      @paste="$event.preventDefault()"
                    />
                  </v-col>
                  <v-col cols="12" sm="12" md="6">
                    <v-text-field
                      v-model="date"
                      v-mask="mask"
                      label="Data de nascimento"
                      placeholder="dd/mm/aaaa"
                      required
                      prepend-icon="mdi-calendar-range"
                    />
                  </v-col>
                  <v-col cols="12" sm="12" md="6">
                    <v-text-field
                      v-model="user.matriculation"
                      label="Matrícula*"
                      required
                      prepend-icon="mdi-file-document-edit"
                      @keypress="validation($event, 'onlyNumber')"
                      @paste="$event.preventDefault()"
                    />
                  </v-col>
                  <v-col cols="12" sm="12" md="6">
                    <v-select
                      v-model="user.document.documentType"
                      prepend-icon="mdi-badge-account-horizontal-outline"
                      :items="documentTypes"
                      item-value="type"
                      item-text="label"
                      label="Tipo de documento*"
                      required
                    />
                  </v-col>
                  <v-col cols="12" sm="12" md="6">
                    <v-text-field
                      v-model="user.document.documentNumber"
                      label="Número do documento*"
                      required
                      prepend-icon="mdi-file-document-edit-outline"
                      
                      @paste="$event.preventDefault()"
                    />
                    <p style="color: #FF5252;" v-if="isValidDocumentNumber">Número do documento inválido *</p>
                  </v-col>
                  <v-col cols="6" md="6">
                    <v-text-field
                      v-model="user.email"
                      label="Email*"
                      prepend-icon="mdi-mail"
                      required
                    />
                    <p style="color: #FF5252;"  v-if="!isValidEmail & user.email.length > 0">Email inválido *</p>
                  </v-col>
                  <v-col cols="6" md="6">
                    <v-text-field
                      v-model="user.password"
                      label="Senha*"
                      :append-icon="show1 ? 'mdi-eye' : 'mdi-eye-off'"
                      :type="show1 ? 'text' : 'password'"
                      prepend-icon="mdi-lock"
                      required
                      @click:append="show1 = !show1"
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <small><b>* Campos obrigatórios</b></small>
                  </v-col>
                  <v-col cols="12" md="12">
                    <v-row>
                      <v-col cols="5">
                        <span class="subtitle-1 font-weight-bold">Entidade</span>
                      </v-col>
                      <v-col cols="5">
                        <span class="subtitle-1 font-weight-bold">Papel na entidade</span>
                      </v-col>
                      <v-col cols="2">
                        <span class="subtitle-1 font-weight-bold">Ações</span>
                      </v-col>
                      <v-col cols="12">
                        <v-divider></v-divider>
                      </v-col>
                      <!-- Percorre o userRoles para mostrar entidades do usuario -->
                      <v-col v-for="(userRole, index) in userRoles" :key="index" cols="12">
                        <!-- Clica para editar a entidade -->
                        <v-row style="position: relative" v-if="editingIndex == index">
                          <!-- Resultado da pesquisa entidade -->
                          <v-col
                            v-if="searchClean && allEntities.length > 0"
                            cols="12"
                            class="pa-0 my-0 ml-3"
                          >
                            <span v-if="searchClean && allEntities.length > 0">
                              Existem
                              <b>{{ allEntities.length }}</b> entidades selecionáveis.
                            </span>
                            <span v-if="selectedEntityName">
                              <br />
                              <b>{{ selectedEntityName }}</b>
                              <v-icon class="ml-1" color="green" x-small>mdi-check</v-icon>
                            </span>
                          </v-col>
                          <!-- Fim resultado pesquisa entidade -->
                          <v-col cols="6">
                            <v-row no-gutters align="center">
                              <v-autocomplete
                                style="max-width: 90%"
                                class="pr-2"
                                v-model="editedEntity.entity"
                                :search-input.sync="entityToSearch"
                                :label="result"
                                solo-inverted
                                flat
                                hide-no-data
                                hide-details
                                :items="allEntities"
                                item-text="name"
                                item-value="id"
                                @change="showSelected(editedEntity.entity)"
                              ></v-autocomplete>
                              <!-- <v-tooltip v-if="!searchClean" bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  v-on="on"
                                  :disabled="entityToSearch == null || entityToSearch.length == 0"
                                  color="primary"
                                  fab
                                  small
                                  @click="searchEntities(entityToSearch)"
                                >
                                  <v-icon small>mdi-magnify</v-icon>
                                </v-btn>
                              </template>
                              <span>Buscar por entidade</span>
                            </v-tooltip>
                            <v-tooltip v-else bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  v-on="on"
                                  v-if="searchClean"
                                  fab
                                  small
                                  icon
                                  @click="cleanSearch"
                                >
                                  <v-icon color="red" @click="cleanSearch"
                                    >mdi-magnify-minus-outline</v-icon
                                  >
                                </v-btn>
                              </template>
                              <span>Limpar busca entidade</span>
                            </v-tooltip> -->
                            </v-row>
                          </v-col>
                          <v-col cols="4">
                            <v-autocomplete
                              v-model="editedEntity.privileges"
                              label="Selecione um papel"
                              solo-inverted
                              flat
                              hide-no-data
                              hide-details
                              :items="allPrivileges"
                              item-text="label"
                              item-value="id"
                            ></v-autocomplete>
                          </v-col>
                          <v-col cols="1">
                            <v-tooltip bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  :disabled="!editedEntity.entity || !editedEntity.privileges"
                                  icon
                                  small
                                  color="primary"
                                  class="mt-2"
                                  v-on="on"
                                  @click="
                                    confirmEdit(index, editedEntity.entity, editedEntity.privileges)
                                  "
                                >
                                  <v-icon color="success">mdi-check</v-icon>
                                </v-btn>
                              </template>
                              <span>Confirmar edição</span>
                            </v-tooltip>
                          </v-col>
                          <v-col cols="1">
                            <v-tooltip bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  icon
                                  small
                                  color="primary"
                                  class="mt-2"
                                  v-on="on"
                                  @click="cancelEdit"
                                >
                                  <v-icon color="error">mdi-close</v-icon>
                                </v-btn>
                              </template>
                              <span>Cancelar edição</span>
                            </v-tooltip>
                          </v-col>
                        </v-row>
                        <!-- Fim clica para editar entidade -->
                        <!-- /// -->
                        <!-- Mostra a entidade se não estiver editando -->
                        <v-row v-if="editingIndex !== index">
                          <v-col cols="5">
                            <span class="subtitle-1">{{ userRole.entity.name }}</span>
                          </v-col>
                          <v-col cols="5">
                            <span class="subtitle-1">{{ userRole.privilege.label }}</span>
                          </v-col>
                          <v-col class="px-0 ml-n3" cols="1">
                            <v-tooltip bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  icon
                                  small
                                  color="primary"
                                  :disabled="editing"
                                  v-on="on"
                                  @click="editEntity(userRole, index)"
                                >
                                  <v-icon color="primary">mdi-pencil</v-icon>
                                </v-btn>
                              </template>
                              <span>Editar entidade/papel</span>
                            </v-tooltip>
                          </v-col>
                          <v-col
                            align="center"
                            class="px-0 ml-n4"
                            cols="1"
                            style="positon: relative"
                          >
                            <div>
                              <v-tooltip
                                bottom
                                :disabled="confirmDelete && index == confirmDeleteIndex"
                              >
                                <template v-slot:activator="{ on }">
                                  <v-btn
                                    icon
                                    small
                                    color="primary"
                                    :disabled="editing"
                                    v-on="on"
                                    @click="removeEntity(index)"
                                  >
                                    <v-icon color="primary">mdi-delete</v-icon>
                                  </v-btn>
                                </template>
                                <span>Remover entidade/papel</span>
                              </v-tooltip>
                            </div>
                          </v-col>
                          <v-row v-if="confirmDelete && index == confirmDeleteIndex" justify="end">
                            <b>Remover?</b>

                            <span
                              class="pl-2 pr-1"
                              @click="confirmRemoveEntity"
                              @mouseenter="mouseEnter = true"
                              @mouseleave="mouseEnter = false"
                              :style="
                                mouseEnter && 'font-weight:bold;cursor:pointer; color: seagreen'
                              "
                              >Sim</span
                            >
                            |
                            <span
                              class="pl-1"
                              @click="cancelRemoveEntity"
                              @mouseenter="mouseEnter2 = true"
                              @mouseleave="mouseEnter2 = false"
                              :style="mouseEnter2 && 'font-weight:bold;cursor:pointer; color: red'"
                              >Não</span
                            >
                          </v-row>
                        </v-row>
                        <!-- Fim mostra entidade se não estiver editando -->
                      </v-col>
                      <!-- Mostra autocomplete ao clicar em "adicionar entidade" -->
                      <v-col cols="12">
                        <v-row style="position: relative" v-if="addingEntity">
                          <!-- Resultado da pesquisa entidade -->
                          <v-col
                            v-if="searchClean && allEntities.length > 0"
                            cols="12"
                            class="pa-0 my-0 ml-3"
                          >
                            <span v-if="searchClean && allEntities.length > 0">
                              Existem
                              <b>{{ allEntities.length }}</b> entidades selecionáveis.
                            </span>
                            <span v-if="selectedEntityName">
                              <br />
                              <b>{{ selectedEntityName }}</b>
                              <v-icon class="ml-1" color="green" x-small>mdi-check</v-icon>
                            </span>
                          </v-col>
                          <!-- Fim resultado pesquisa entidade -->
                          <v-col cols="6">
                            <v-row no-gutters align="center">
                              <v-autocomplete
                                style="max-width: 90%"
                                class="pr-2"
                                v-model="editedEntity.entity"
                                :search-input.sync="entityToSearch"
                                :label="result"
                                solo-inverted
                                flat
                                hide-no-data
                                hide-details
                                :items="allEntities"
                                item-text="name"
                                item-value="id"
                                @change="showSelected(editedEntity.entity)"
                              ></v-autocomplete>
                              <!-- <v-tooltip v-if="!searchClean" bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  v-on="on"
                                  :disabled="entityToSearch == null || entityToSearch.length == 0"
                                  color="primary"
                                  fab
                                  small
                                  @click="searchEntities(entityToSearch)"
                                >
                                  <v-icon small>mdi-magnify</v-icon>
                                </v-btn>
                              </template>
                              <span>Buscar por entidade</span>
                            </v-tooltip>
                            <v-tooltip v-else bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  v-on="on"
                                  v-if="searchClean"
                                  fab
                                  small
                                  icon
                                  @click="cleanSearch"
                                >
                                  <v-icon color="red" @click="cleanSearch"
                                    >mdi-magnify-minus-outline</v-icon
                                  >
                                </v-btn>
                              </template>
                              <span>Limpar busca entidade</span>
                            </v-tooltip> -->
                            </v-row>
                          </v-col>
                          <v-col cols="4">
                            <v-autocomplete
                              v-model="editedEntity.privileges"
                              label="Selecione um papel"
                              solo-inverted
                              flat
                              hide-no-data
                              hide-details
                              :items="allPrivileges"
                              item-text="label"
                              item-value="id"
                            ></v-autocomplete>
                          </v-col>
                          <v-col cols="1">
                            <v-tooltip bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  :disabled="!editedEntity.entity || !editedEntity.privileges"
                                  icon
                                  small
                                  color="primary"
                                  class="mt-2"
                                  v-on="on"
                                  @click="
                                    addToEntities(editedEntity.entity, editedEntity.privileges)
                                  "
                                >
                                  <v-icon color="success">mdi-check</v-icon>
                                </v-btn>
                              </template>
                              <span>Confirmar</span>
                            </v-tooltip>
                          </v-col>
                          <v-col cols="1">
                            <v-tooltip bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  icon
                                  small
                                  color="primary"
                                  class="mt-2"
                                  v-on="on"
                                  @click="cancelAddEntity"
                                >
                                  <v-icon color="error">mdi-close</v-icon>
                                </v-btn>
                              </template>
                              <span>Cancelar</span>
                            </v-tooltip>
                          </v-col>
                        </v-row>
                        <v-row no-gutters>
                          <v-col cols="12" align="center">
                            <v-btn color="primary" outlined :disabled="editing" @click="addEntity">
                              Adicionar entidade
                            </v-btn>
                          </v-col>
                        </v-row>
                      </v-col>
                    </v-row>
                  </v-col>
                </v-row>
              </v-container>
            </div>
          </v-form>
          <!-- Adicionar usuario ja existente na entidade -->
          <div v-if="actualTab == 1">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12" align="center">
                  <div class="my-4" style="width: 70%; text-align: start;">
                    <v-icon class="pr-2 pb-1" color="primary">mdi-numeric-1-circle</v-icon
                    ><span class="primary--text" style="font-size: 1rem; font-weight: 500"
                      >Escolha o usuário:</span
                    >
                  </div>
                  <v-autocomplete
                    style="width: 70%"
                    v-model="selectedUser"
                    label="Digite o nome do usuário"
                    solo-inverted
                    flat
                    hide-no-data
                    hide-details
                    :items="availableUsers"
                    item-text="name"
                    item-value="id"
                    @change="handleUser"
                  ></v-autocomplete>
                  <div v-if="selectedUser" class="my-4" style="width: 70%; text-align: start;">
                    <b>Nome:</b> {{ selectedUserInfo.name }}<br />
                    <b>Matrícula:</b> {{ selectedUserInfo.matriculation }}<br />
                    <b>E-mail:</b> {{ selectedUserInfo.email }}
                    <br />
                    <br />
                    <v-icon class="pr-2 pb-1" color="primary">mdi-numeric-2-circle</v-icon
                    ><span class="primary--text" style="font-size: 1rem; font-weight: 500"
                      >Escolha o papel do usuário na entidade:</span
                    >
                  </div>
                  <v-autocomplete
                    v-if="selectedUser"
                    style="width: 70%"
                    v-model="selectedRole"
                    label="Selecione o papel"
                    solo-inverted
                    flat
                    hide-no-data
                    hide-details
                    :items="privilegesToSelect"
                    item-text="label"
                    item-value="id"
                  ></v-autocomplete>
                </v-col>
              </v-row>
            </v-container>
          </div>
        </v-card-text>
        <v-card-actions class="mt-n3 pb-6 pr-6">
          <v-spacer />
          <v-btn color="lighter" text @click="handleClose">Cancelar</v-btn>
          <v-btn
            v-if="actualTab == 0"
            color="primary"
            @click="handleCreate"
            elevation="0"
            :disabled="
              !user.name ||
                !user.surname ||
                !user.matriculation ||
                !user.document.documentType ||
                !user.document.documentNumber ||
                !user.email ||
                !user.password ||
                user.entities.length == 0 || 
                !isValidEmail || 
                isValidDocumentNumber
            "
            >Adicionar</v-btn
          >
          <v-btn
            v-if="actualTab == 1"
            color="primary"
            @click="handleCreate2"
            elevation="0"
            :disabled="!selectedRole || !selectedUser || !isValidEmail || isValidDocumentNumber"
            >Adicionar</v-btn
          >
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import User from '../../services/user'
import Management from '../../services/management'
import { mask } from 'vue-the-mask'
import Form from '../../utils/form'

export default {
  name: 'UsersCreate',
  components: {},
  directives: {
    mask,
  },
  data: () => ({
    actualTab: 0,
    selectedUser: '',
    selectedUserInfo: {},
    selectedRole: '',
    availableUsers: [],
    privilegesToSelect: [],
    canAddUserInEntity: false,
    candAddNewUser: false,
    user: {
      name: '',
      surname: '',
      birthday: '',
      password: '',
      matriculation: '',
      email: '',
      document: {
        documentType: '',
        documentNumber: '',
      },
      entities: [],
    },
    date: null,
    documentTypes: [
      { type: 'CPF', label: 'Cpf' },
      { type: 'passport', label: 'Passaporte' },
    ],
    mask: '##/##/####',
    onlyLetters: 'SSSSSSSS',
    valid: false,
    show1: false,
    confirmDelete: false,
    confirmDeleteIndex: -1,
    mouseEnter: false,
    mouseEnter2: false,
    editing: false,
    addingEntity: false,
    editingIndex: -1,
    editedEntity: {
      entity: '',
      privileges: '',
    },
    entityToSearch: '',
    selectedEntityName: '',
    searchClean: false,
    label: {
      initial: 'Por favor, digite o nome da entidade para buscar',
      noResult: 'Desculpe, nenhuma entidade encontrada',
      result: 'Selecione a entidade',
    },
    result: 'Por favor, digite o nome da entidade para buscar',
    userRoles: [],
    allPrivileges: [],
    allEntities: [],
  }),
  computed: {
    isValidEmail(){
      return /^[^@]+@\w+(\.\w+)+\w$/.test(this.user.email)
    },
    isValidDocumentNumber(){
      if(this.user.document.documentType === 'CPF'){
        return !this.cpfValidation(this.user.document.documentNumber) && this.user.document.documentNumber.length > 0 
      }
      if(this.user.document.documentType === 'passport'){
        return !/^[a-zA-Z0-9]+$/.test(this.user.document.documentNumber) && this.user.document.documentNumber.length > 0
      }
    },
    ...mapState('user', ['usersCreate']),
  },
  async created() {
    this.readPrivileges()
    const actionsMap = this.$store.state.user.mappedActions
    this.candAddNewUser = actionsMap.get('userCreate') ? true : false
    this.canAddUserInEntity = actionsMap.get('userAddOnEntity') ? true : false
    if (!this.candAddNewUser) this.selectTab1()
  },
  methods: {
    ...mapMutations('user', ['UPDATE_USERS_CREATE']),
    validation($event, type) {
      return Form.validation($event, type)
    },
    cpfValidation(cpf){
      const notDig = i => !['.', '-', ' '].includes(i)
      const prepare = cpf => cpf.trim().split('').filter(notDig).map(Number)
      const is11Len = cpf => cpf.length === 11
      const notAllEquals = cpf => !cpf.every(i => cpf[0] === i)
      const onlyNum = cpf => cpf.every(i => !isNaN(i))

      const calcDig = limit => (a, i, idx) => a + i * ((limit + 1) - idx)
      const somaDig = (cpf, limit) => cpf.slice(0, limit).reduce(calcDig(limit), 0)
      const resto11 = somaDig => 11 - (somaDig % 11)
      const zero1011 = resto11 => [10, 11].includes(resto11) ? 0 : resto11

      const getDV = (cpf, limit) => zero1011(resto11(somaDig(cpf, limit)))
      const verDig = pos => cpf => getDV(cpf, pos) === cpf[pos]

      const checks = [is11Len, notAllEquals, onlyNum, verDig(9), verDig(10)]
      const checkAll = cpf => checks.map(f => f(cpf)).every(r => !!r)

      return checkAll(prepare(cpf))
    },
    rgValidation(rg){
      var digitos = rg.split("");
      digitos.pop()
      var totais = [];
      var total = 0;

      // Multiplicamos os que seriam da primeira linha com os da segunda    
      digitos.forEach(function (digito, index) {
          totais.push(Number(digito) * (2 + index));
      });

      // Multiplicamos as colunas
      totais.forEach(function(numero) { total += numero });

      // Descobrimos o resto da divisão
      var resto = total % 11;

      var lastDigitCalculated = 11 - resto

      console.log("lastDigitCalculated: ", lastDigitCalculated);
      console.log("RG-ValidatorDigit: ", rg[rg.length - 1]);

      return parseInt(rg[rg.length - 1]) !== lastDigitCalculated
    },
    selectTab0() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.actualTab = 0
      }, 200)
    },
    selectTab1() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(async () => {
        await this.readPrivileges2()
        await this.readAllUserBD()
        this.actualTab = 1
      }, 200)
    },
    handleUser(userId) {
      for (let i = 0; i < this.availableUsers.length; i++) {
        if (this.availableUsers[i].id == userId)
          return (this.selectedUserInfo = this.availableUsers[i])
      }
    },

    cleanSearch() {
      this.searchClean = false
      this.allEntities = []
      this.selectedEntityName = ''
      this.editedEntity.entity = ''
      this.editedEntity.privileges = ''
      this.result = this.label.initial
    },
    showSelected(id) {
      if (this.allEntities.length > 0)
        this.allEntities.forEach((entity) => {
          if (entity.id === id) {
            if (entity.firstName) {
              this.selectedEntityName = entity.firstName + ' / ' + entity.name
              return
            } else {
              this.selectedEntityName = entity.name
              return
            }
          }
        })
    },
    async searchEntities(item) {
      if (!item) {
        item = ''
      }
      this.result = this.label.initial
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('updateEntity').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readEntityByName(entityId, actionId, item)
        this.allEntities = ret.data
        this.searchClean = true

        if (this.allEntities.length > 0) {
          this.result = this.label.result
        } else {
          this.result = this.label.noResult
        }
      } catch (e) {
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async readPrivileges() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('readPrivilege').id
      try {
        let ret = await Management.readPrivilege(entityId, actionId)
        if (ret.success) {
          this.allPrivileges = ret.data
        }
      } catch (e) {
        console.log(e)
      }
    },
    async readPrivileges2() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const numberOfActions = routedEntity.privileges.actions.length
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('readPrivilege').id
      try {
        let ret = await Management.readPrivilege(entityId, actionId)
        if (ret.success) {
          let availablePrivileges = ret.data.filter((privilege) => {
            return privilege.actions.length <= numberOfActions
          })
          this.privilegesToSelect = availablePrivileges
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async readAllUserBD() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userRead').id
      try {
        let ret = await Management.readAllUserBD(entityId, actionId)
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          console.log(ret.data, 'TODOS USUÁRIOS')
          ret.data.forEach((user) => {
            user.name = `${user.name} ${user.surname}`
          })
          this.availableUsers = ret.data
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    handleClose() {
      this.$refs.form.reset()
      this.cleanSearch()
      this.UPDATE_USERS_CREATE(false)
      this.userRoles = []
      this.editing = false
      this.addingEntity = false
      this.confirmDelete = false
      this.confirmDeleteIndex = -1
      this.user = {
        name: '',
        surname: '',
        birthday: '',
        password: '',
        matriculation: '',
        email: '',
        document: {
          documentType: '',
          documentNumber: '',
        },
        entities: [],
      }
      if (!this.candAddNewUser) this.actualTab = 1
      else this.actualTab = 0
      this.selectedUser = ''
      this.selectedUserInfo = {}

      //scroll padrão sempre pra cima
      this.$nextTick(() => {
        this.$refs.scrollY.scrollTop = 0
      })
    },
    async handleCreate() {
      if (this.date) {
        let day = Number(this.date.slice(0, 2))
        let month = Number(this.date.slice(3, 5) - 1)
        let year = Number(this.date.slice(6, 10))
        let data = new Date(year, month, day)
        console.log(data, 'data timestamp')
        let timestamp = data.getTime()
        this.user.birthday = timestamp
      }
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userCreate').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.createUser(entityId, actionId, this.user)
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$parent.readUsers()
          this.handleClose()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Usuário <b>adicionado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.log('catch create role', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.cleanSearch()
        this.userRoles = []
        this.editing = false
        this.addingEntity = false
        this.user = {
          name: '',
          surname: '',
          birthday: '',
          password: '',
          matriculation: '',
          email: '',
          document: {
            documentType: '',
            documentNumber: '',
          },
          entities: [],
        }
      }
    },
    async handleCreate2() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userAddOnEntity').id
      let data = {
        id: this.selectedUser,
        to: entityId,
        privileges: this.selectedRole,
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.addUserOnEntity(entityId, actionId, data)
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$parent.readUsers()
          this.handleClose()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Usuário foi <b>adicionado</b> na entidade!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          if (
            ret.data.description ==
            "We didn't find an answer to error userAlreadyIsInThisEntity on model user"
          ) {
            this.$store.commit('user/UPDATE_LOADING', false)
            this.handleClose()
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'O usuário selecionado já está nessa entidade!',
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }
          if (
            ret.data.description ==
            "We didn't find an answer to error userCantBeUpdateFromThisEntity on model user"
          ) {
            this.$store.commit('user/UPDATE_LOADING', false)
            this.handleClose()
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message:
                '<b>Um erro inesperado aconteceu</b>, não foi possível adicionar esse usuário a entidade.',
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }
        }
      } catch (e) {
        console.log('catch create role', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.cleanSearch()
        this.userRoles = []
        this.editing = false
        this.addingEntity = false
        this.user = {
          name: '',
          surname: '',
          birthday: '',
          password: '',
          matriculation: '',
          email: '',
          document: {
            documentType: '',
            documentNumber: '',
          },
          entities: [],
        }
        this.selectedRole = ''
        this.selectedUser = ''
      }
    },
    addEntity() {
      this.editing = true
      this.addingEntity = true
      this.confirmDelete = false
      this.searchEntities()
    },
    cancelAddEntity() {
      this.editingIndex = -1
      this.editing = false
      this.addingEntity = false
      this.cleanSearch()
    },
    addToEntities(entity, privilege) {
      this.editing = false
      this.addingEntity = false

      let selectedEntity = this.allEntities.filter((value) => {
        return value.id == entity
      })[0]
      let selectedPrivilege = this.allPrivileges.filter((value) => {
        return value.id == privilege
      })[0]

      let userRole = {
        entity: selectedEntity,
        privilege: selectedPrivilege,
      }
      this.userRoles.push(userRole)

      let newEntity = { entity: entity, privileges: privilege }
      this.user.entities.push(newEntity)

      this.cleanSearch()
    },
    editEntity(entity, index) {
      this.searchEntities()
      this.editing = true
      this.editingIndex = index
      let arrayEdit = []
      arrayEdit.push(entity.entity)
      this.allEntities = arrayEdit
      this.editedEntity.entity = entity.entity.id
      this.editedEntity.privileges = entity.privilege.id
    },
    confirmEdit(index, entity, privilege) {
      //atualiza na array User a edição
      let editedEntity = { entity: entity, privileges: privilege }
      this.user.entities[index] = editedEntity

      //atualiza na array userRoles
      let selectedEntity = this.allEntities.filter((value) => {
        return value.id == entity
      })[0]
      let selectedPrivilege = this.allPrivileges.filter((value) => {
        return value.id == privilege
      })[0]

      let editedUserRole = {
        entity: selectedEntity,
        privilege: selectedPrivilege,
      }
      this.userRoles[index] = editedUserRole

      // zera campos
      this.editing = false
      this.editingIndex = -1
      this.editedEntity.entity = ''
      this.editedEntity.privileges = ''
      this.cleanSearch()
    },
    cancelEdit() {
      this.editedEntity.entity = ''
      this.editedEntity.privileges = ''
      this.editingIndex = -1
      this.editing = false
    },
    removeEntity(index) {
      this.confirmDelete = true
      this.confirmDeleteIndex = index
      this.mouseEnter = false
      this.mouseEnter2 = false
    },
    confirmRemoveEntity(index) {
      this.user.entities.splice(index, 1)
      this.userRoles.splice(index, 1)
      this.cleanSearch()
      this.confirmDelete = false
      this.confirmDeleteIndex = -1
      this.mouseEnter = false
    },
    cancelRemoveEntity(index) {
      this.confirmDelete = false
      this.confirmDeleteIndex = -1
      this.mouseEnter2 = false
    },
  },
}
</script>

<style></style>
